/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.api;

import java.util.List;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory;

public interface EntaxyProducerService {

	public static interface INSTRUCTIONS {
		
		public static final String PRINT_OUTPUT = "printOutput";
		public static final String SKIP = "skip";
		
		public static interface ARTIFACT {

			public static final String VERSION = "artifact.version";
			public static final String TIMESTAMP = "artifact.timestamp";
			public static final String VERSION_POLICY = "artifact.version.policy";
			
		}
		
	};
	
	public ProducerResult produce(String configuration);
	public ProducerResult produce(JsonObject configuration);

	public ProducerResult produce(String configuration, String instructions);
	public ProducerResult produce(JsonObject configuration, String instructions);
	
	public List<EntaxyProducer> getAllProducers();
	public EntaxyProducer getProducerForType(String type);
	public EntaxyFactory	 findFactoryById(String factoryId);
	
	public List<ProducingCommandExecutor> getAvailableCommands();
	public void registerCommand(ProducingCommandExecutor commandExecutor);
	public ProducingCommandExecutor getCommandById(String id);
}
